package turbowin;


import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/*
 * mylogfiles.java
 *
 * Created on 12 november 2008, 18:27
 */



/**
 *
 * @author  Martin
 */
final public class mylogfiles extends javax.swing.JFrame {

    /** Creates new form mylogfiles */
    public mylogfiles() {
        initComponents();
        initLogComponents();
        setLocation(main.x_pos_frame, main.y_pos_frame);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
   // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
   private void initComponents() {

      jLabel1 = new javax.swing.JLabel();
      jTextField1 = new javax.swing.JTextField();
      jButton3 = new javax.swing.JButton();
      jLabel2 = new javax.swing.JLabel();
      jLabel3 = new javax.swing.JLabel();
      jLabel4 = new javax.swing.JLabel();
      jLabel5 = new javax.swing.JLabel();
      jSeparator1 = new javax.swing.JSeparator();
      jButton1 = new javax.swing.JButton();
      jButton2 = new javax.swing.JButton();

      setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
      setTitle("Log files");
      setMinimumSize(new java.awt.Dimension(800, 600));
      setResizable(false);

      jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel1.setText("log files folder");

      jTextField1.setEditable(false);

      jButton3.setText("folder");
      jButton3.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            Log_files_folder_button_actionPerformed(evt);
         }
      });

      jLabel2.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
      jLabel2.setForeground(new java.awt.Color(0, 0, 255));
      jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel2.setText("The log files include important data which is of particular value for climate studies and research.\n");

      jLabel3.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
      jLabel3.setForeground(new java.awt.Color(0, 0, 255));
      jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel3.setText("Downloading of the log files should be done at routine intervals (ideally not exceeding six months) either by a visiting PMO ");

      jLabel4.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
      jLabel4.setForeground(new java.awt.Color(0, 0, 255));
      jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel4.setText("or by the ships observers themselves. Do not copy or move the log files with another program.");

      jLabel5.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
      jLabel5.setForeground(new java.awt.Color(0, 0, 255));
      jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel5.setText("In this program select Maintenance -> Move log files");

      jButton1.setText("OK");
      jButton1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            OK_button_actionPerformed(evt);
         }
      });

      jButton2.setText("Cancel");
      jButton2.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            Cancel_button_actionPerformed(evt);
         }
      });

      javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
      getContentPane().setLayout(layout);
      layout.setHorizontalGroup(
         layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.TRAILING)
               .addGroup(layout.createSequentialGroup()
                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                     .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                     .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                     .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jTextField1)
                        .addGap(18, 18, 18)
                        .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE))
                     .addComponent(jLabel5, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                     .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                     .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, 755, Short.MAX_VALUE))
                  .addContainerGap())))
         .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
            .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(18, 18, 18)
            .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
      );
      layout.setVerticalGroup(
         layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(layout.createSequentialGroup()
            .addGap(132, 132, 132)
            .addComponent(jLabel1)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGap(140, 140, 140)
            .addComponent(jLabel2)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel3)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel4)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel5)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 115, Short.MAX_VALUE)
            .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(15, 15, 15)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGap(15, 15, 15))
      );

      pack();
   }// </editor-fold>//GEN-END:initComponents

   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
private void initLogComponents()
{
   /* put global meta data vars from configuration file into appropriate components */

   // full path of logs dir (amongst others the log for immt.log)
   jTextField1.setText(main.logs_dir);

   /* In offline mode the logs dir is fixed (sub dir of main dir, main dir is the dir where jar file is located) */
   if (main.offline_mode == true)
   {
      jTextField1.setEnabled(false);
      jButton3.setEnabled(false);
   }
}



   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
    private void OK_button_actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OK_button_actionPerformed
   // TODO add your handling code here:

   boolean doorgaan = true;
   String info = "";


   // get logs dir 
   main.logs_dir = jTextField1.getText().trim();
   
   if (main.logs_dir.equals(""))
   {
      doorgaan = false;
   }
   
   
   if (doorgaan)
   {
      // if not done before, create sub dir TURBOWIN_SYSTEM_LOGS (turbowin_system)
      String turbowin_system_logs_dir = main.logs_dir + java.io.File.separator + main.TURBOWIN_SYSTEM_LOGS_DIR;
      final File dir_turbowin_system_logs = new File(turbowin_system_logs_dir);  
      
      if (dir_turbowin_system_logs.exists() == false)
      {
         dir_turbowin_system_logs.mkdir();  
         main.log_turbowin_system_message("[GENERAL] created dir " + turbowin_system_logs_dir);
      }
   }


   if (doorgaan)
   {
      // write meta (station) data to muffins or configuration files
      if (main.offline_mode_via_cmd == true)
      {
         main.schrijf_configuratie_regels();          
      }
      else // so offline_via_jnlp mode or online (webstart) mode
      {
         //main.set_muffin();
         main.schrijf_configuratie_regels();
      }   

      /* message */
      info = "Changes will take effect inmediatelly. Not necessary to restart";
      JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " info", JOptionPane.INFORMATION_MESSAGE);

      /* close this E-mail settings input page */
      setVisible(false);
      dispose();
   }
}//GEN-LAST:event_OK_button_actionPerformed

    
    
    /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
private void Cancel_button_actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Cancel_button_actionPerformed
// TODO add your handling code here:
   setVisible(false);
   dispose();
}//GEN-LAST:event_Cancel_button_actionPerformed



   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
private void Log_files_folder_button_actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Log_files_folder_button_actionPerformed
// TODO add your handling code here:

/*
Note:  If you intend to distribute your program as an unsigned Java Web Start application,
        then instead of using the JFileChooser API you should use the file services provided
        by the JNLP API. These services FileOpenService and FileSaveService not only
        provide support for choosing files in a restricted environment, but also take care of
        actually opening and saving them. An example of using these services is in JWSFileChooserDemo.
        Documentation for using the JNLP API can be found in the Java Web Start lesson.
       (http://java.sun.com/docs/books/tutorial/uiswing/components/filechooser.html)
*/

   // pop-up the file/directory chooser dialog box
   //JFileChooser chooser = new JFileChooser(".");                // present dir
   JFileChooser chooser = new JFileChooser();                     // Constructs a JFileChooser pointing to the user's default directory. This default depends on the operating system. It is typically the "My Documents" folder on Windows, and the user's home directory on Unix. 
   chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);                                   // now the user can only select directories
   int result = chooser.showSaveDialog(mylogfiles.this);

   if (result == JFileChooser.APPROVE_OPTION)
   {
      main.logs_dir = chooser.getSelectedFile().getPath();                                        // getSelectedFile() -> in this case returns not a file but a directory !

      // update the selected log path field on this log selection form 
      jTextField1.setText(main.logs_dir);
      
   } // if (result == JFileChooser.APPROVE_OPTION
   
}//GEN-LAST:event_Log_files_folder_button_actionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
         @Override
            public void run() {
                new mylogfiles().setVisible(true);
            }
        });
    }

   // Variables declaration - do not modify//GEN-BEGIN:variables
   private javax.swing.JButton jButton1;
   private javax.swing.JButton jButton2;
   private javax.swing.JButton jButton3;
   private javax.swing.JLabel jLabel1;
   private javax.swing.JLabel jLabel2;
   private javax.swing.JLabel jLabel3;
   private javax.swing.JLabel jLabel4;
   private javax.swing.JLabel jLabel5;
   private javax.swing.JSeparator jSeparator1;
   private javax.swing.JTextField jTextField1;
   // End of variables declaration//GEN-END:variables

   //private final String LOGS_HELP_DIR = "logs.html";
}
